import 'dart:math';

import '../lib/dartgl.dart';
import '../lib/dartgl_sdl.dart';

var arrays;
var textures;
var program;
var location;
const int COUNT = 10; 

void main() {
  print("SDL2 ${SDL_Init()}");

  SDL_GL_SetAttribute(SDL_GL_CONTEXT_MAJOR_VERSION, 3);
  SDL_GL_SetAttribute(SDL_GL_CONTEXT_MINOR_VERSION, 0);
 
  Pointer w = SDL_CreateWindow("OpenGL", 100, 100, 600, 400, SDL_WINDOW_OPENGL|SDL_WINDOW_RESIZABLE);
  Pointer c = SDL_GL_CreateContext(w);
  
  SDL_GL_MakeCurrent(w, c);
  SDL_GL_SetSwapInterval(0);
  
  prepare();
    
  double time = 0.0;
  var exit = false;

  var startTime = new DateTime.now();
  var event = new Event();
  while (!exit){
    
    while (SDL_PollEvent(event) != 0){
      //print(event.type);
      if (event.type == 0x100) {
        exit = true;
      }
    }
    
    time += PI/64;
    draw(time);
        
    SDL_GL_SwapWindow(w);
  }
  print(new DateTime.now().difference(startTime));
}


void draw(double time){
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);  
    
}

void prepare(){
  print(glGetString(GL_VERSION));
  print(glGetString(GL_VENDOR));
  print(glGetString(GL_RENDERER));
  print(glGetString(GL_SHADING_LANGUAGE_VERSION));
  glClearColor(0.0, 0.7, 0.99, 0.0);
}
